package org.eso.ohs.core.dbb.client;

import javax.swing.JTextField;

import org.eso.ohs.core.dbb.sql.DbbSqlChunk;
import org.eso.ohs.core.gui.models.InputMaskModel;

/**
 * TBD
 *
 * @version $Revision: 1.4 $
 * @author ???
 */

public class DbbTextFieldPattern extends DbbTextField {

    public final static String SQL_WILD_CARD = "%";
	
    
    /** Create a case insensitive DbbTextField object with a default width 
     * 
     * @param labeltext	Label text to be displayed.
     * @param chunk	DbbSqlChunk object
     * @see org.eso.ohs.core.dbb.client.DbbTextField
     */
    public DbbTextFieldPattern(String labeltext,DbbSqlChunk chunk) {
		super(labeltext, chunk);  
		
    }
	
	/** Create a DbbTextField object with a default width
     * 
     * @param labeltext	Label text to be displayed.
     * @param chunk	DbbSqlChunk object
     * @param isCaseSensitive a Boolean
     * @see org.eso.ohs.core.dbb.client.DbbTextField
     */
	public DbbTextFieldPattern(String labeltext,DbbSqlChunk chunk, boolean isCaseSensitive) {
		super(labeltext, chunk, isCaseSensitive);  
		
		
	    }

    /** Create a DbbTextField object.
     * 
     * @param labeltext	Label text to be displayed.
     * @param chunk	DbbSqlChunk object
     * @param width	Width of the widget in characters
     */
    // amchavan, 13-Jun-2002: added
    public DbbTextFieldPattern( String labeltext, DbbSqlChunk chunk, int width ) {
		super( labeltext, chunk, width);   
    }
	
	 /** Create a DbbTextField object.
     * 
     * @param labeltext	Label text to be displayed.
     * @param chunk	DbbSqlChunk object
     * @param width	Width of the widget in characters
     * @param isCaseSensitive a Boolean
     */
    // amchavan, 13-Jun-2002: added
    public DbbTextFieldPattern( String labeltext, DbbSqlChunk chunk, int width, boolean isCaseSensitive ) {
		super( labeltext, chunk, width, isCaseSensitive);   
    }

    /** 
     * Get the widget value.
     *
     * @return The currently displayed string value. 
     */
    public String get() {
	String text = ((JTextField)widget_).getText();
	if(text != null && text.length() > 0)  
	    text = SQL_WILD_CARD + ((JTextField)widget_).getText() + SQL_WILD_CARD;  
	
	if (!isCaseSensitive){
		text = text.toLowerCase();
	}
	return text;
    }

    /** 
     * Set the widget value.
     *
     * @return The currently displayed string value. 
     */
    public void set(String valueWrap) {
	String value = valueWrap;
	if (value != null && value.length()>=2) { 
	    value =  value.substring(1,value.length()-1);
	}
	((JTextField) widget_).setText(String.valueOf(value));
	fireDbbWidgetAction();                                    
    }
    
    /** Set the Model*/
    public void setModel(InputMaskModel model){
    	JTextField tf = (JTextField)widget_;
    	tf.setDocument(model);
    }
	
	
}

