package org.eso.ohs.core.dbb.client;


import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.TextDisplayWidget;

/**
 * Shows the DbbView table as text with an option to print it
 * <p>
 * $Id: DisplayTableAsTextAction.java,v 1.2 2005/11/16 00:51:05 tcanavan Exp $
 * <br>
 * @version $Revision: 1.2 $
 * @author D. Dorigo
 */

public class DisplayTableAsTextAction extends ActionSuperclass {

    private DbbView view_;
    private String heading_;
    private String title_;
    private JFrame parentFrame_;
    

    /**
     * constructor     
     * 
     * @param view              DbbView to be displayed
     * @param title             title of this window
     */
    public DisplayTableAsTextAction(
    		DbbView view,
            String title,
            String heading,
            JFrame frame) {
        super(view, title);
        view_ = view;
        title_ = title;
        heading_ = heading;
        parentFrame_ = frame;
    }

    /**
     * action starting method
     *
     * @param ev        user-initiated ActionEvent
     */
    public void actionPerformedImpl(ActionEvent ev) {
    	Cursor currentCursor = parentFrame_.getCursor();
        parentFrame_.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        showText();
        parentFrame_.setCursor(currentCursor);
    }

    private void showText() {
        StringBuffer text = new StringBuffer();
        if(heading_ != null && heading_.length() > 0) {
            text.append("\n" + heading_);        	
        }
        text.append("\nNumber of Rows: " + view_.getRows() + "\n\n");
        text.append(view_.printTable());

        TextDisplayWidget display =
            new TextDisplayWidget(title_, true, false, true);
        display.setCurrentPathAsLast();
        display.setTextArea(text.toString());
        display.setSize(new Dimension(600, 400));
        display.setVisible(true);
    }
}

