package org.eso.ohs.persistence.dao;

import org.eso.ohs.dfs.Account;
import org.eso.ohs.dfs.AccountProfile;
import org.springframework.dao.DataAccessException;

/**
 * AccountDAO interface.   
 * Class EsoUserDAO
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.5 $
 * @author tcanavan, Aug 11, 2005
 */

// $Id: AccountDAO.java,v 1.5 2005/11/16 16:15:42 fsogni Exp $
 


public interface AccountDAO {
     public Account getAccount(final Integer id) throws DataAccessException ;
     public Account getAccount(String userName)throws DataAccessException ;
     public Account getUserAndProfiles(String userName)throws DataAccessException ;
     public AccountProfile getDefaultProfile(String userName) throws DataAccessException;
     public void updateProfile(AccountProfile accProfile) throws DataAccessException;
     public void create(Account account) throws DataAccessException ;    
     public void updateAccount(Account account) throws DataAccessException;
     public void changePassword(Account account) throws DataAccessException;
     public void delete(Account account) throws DataAccessException;    
     public boolean accountExists(String userName) throws DataAccessException;
     public AccountProfile getDefaultProfile(final Account account) throws DataAccessException;
     public Account getAccountRoles(final String userName) throws DataAccessException;
     
} 
