package org.eso.ohs.persistence.dao;

import org.eso.ohs.dfs.AccountInterface;
import org.eso.ohs.dfs.AccountProfile;
import org.springframework.dao.DataAccessException;

/**
 * AccountDAO interface.   
 * Class EsoUserDAO
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.2 $
 * @author tcanavan, Aug 11, 2005
 */

// $Id: AccountDAOProxy.java,v 1.2 2005/11/16 10:07:21 gdonino Exp $
 


public interface AccountDAOProxy {
     public AccountInterface getAccount(final Integer id) throws DataAccessException ;
     public AccountInterface getAccount(String userName)throws DataAccessException ;
     public AccountInterface getUserAndProfiles(String userName)throws DataAccessException ;
     public AccountProfile getDefaultProfile(String userName) throws DataAccessException;
     public void updateProfile(AccountProfile accProfile) throws DataAccessException;
     public void create(AccountInterface account) throws DataAccessException ;    
     public void updateAccount(AccountInterface account) throws DataAccessException;
     public void changePassword(AccountInterface account) throws DataAccessException;
     public void delete(AccountInterface account) throws DataAccessException;    
     public boolean accountExists(String userName) throws DataAccessException;
     public AccountProfile getDefaultProfile(final AccountInterface account) throws DataAccessException;
     
} 
