package org.eso.ohs.phase2.actions;

import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.border.Border;
import javax.swing.plaf.BorderUIResource;

import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.utilities.MsgManager;
import org.eso.ohs.phase2.visiplot.ColorEditor;


/**
 * Open the JColorChooser
 * <p>
 * $Id: ColorEditorAction.java,v 1.3 2005/11/02 14:07:52 gdonino Exp $
 * 
 * @version $Revision $
 * @author Gabriele Donino
 */
public class ColorEditorAction extends ActionSuperclass {
	JFrame parentFrame_ = null;
	String title_ = null;
	JComponent component_;

	/**
	 * 
	 * @param component The component the action is associated to.
	 * @param parentFrame parent frame.
	 * @param title title
	 */
	public ColorEditorAction(JComponent component, JFrame parentFrame, String title) {
		super(parentFrame, title);
		
		/* check for the precondition */
		if (parentFrame == null) MsgManager.errPrecondition("The parentFrame attribute is null");
		if (title == null) MsgManager.errPrecondition("The title attribute is null");
		/* DbC */
	
		parentFrame_ = parentFrame;
		title_ = title;	
		component_ = component;
	}
	
	private void createAndShowGUI(JFrame frame, String title) {
		assert(frame != null): MsgManager.errPrecondition("The frame is null");
		JFrame.setDefaultLookAndFeelDecorated(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JComponent tmpComponent = new JButton("temp");
		tmpComponent.setBackground(component_.getBackground());
		ColorEditor dialog = new ColorEditor(tmpComponent, frame, true,title);
		
		dialog.pack();
		dialog.setVisible(true);
		if (dialog.getUserChoice() == JOptionPane.OK_OPTION) {
			Border border = BorderUIResource.getRaisedBevelBorderUIResource(); 
			component_.setBorder(border);
			component_.setBackground(tmpComponent.getBackground());
			component_.setForeground(tmpComponent.getBackground());	
		}
	}

	/**
	 * action starting method
	 * 
	 * @param ev
	 *            user-initiated ActionEvent
	 */
	public void actionPerformedImpl(ActionEvent ev) {
		createAndShowGUI(parentFrame_, title_);
		
	}
}