package org.eso.ohs.phase2.apps.p2pp;

/** 
 * This class is defines a the implementation for creation of
 * P2PPInstrumentList objects. 
 * 
 * @author Nick Kornweibel for ESO.
 */
 
import org.eso.ohs.instruments.InstrumentList;
import org.eso.ohs.instruments.InstrumentListFactory;
 
public class P2PPInstrumentListFactory implements InstrumentListFactory {
    
    private String ipCacheDir_ = null;
    
    private String instDir_ = null;
    
    private boolean ipMode_;
    
    
    
    /**
     * create a factory, specifying the cache directory to use..
     */
    public P2PPInstrumentListFactory(boolean ipMode,String instDir,String ipc) {
        ipCacheDir_ = ipc;
        instDir_  = instDir;
        ipMode_ = ipMode;
    }
    
    /**
     * @return an InstrumentList object.
     */
    public InstrumentList getInstrumentList() {
        return new P2PPInstrumentList(ipMode_,instDir_,ipCacheDir_);
    }
}