package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.persistence.OHSApplication;
import org.eso.ohs.phase2.apps.p2pp.MainWindow;

/**
 * Action class to display the contents of the database.
 *
 * <p>
 * $Id: Phase1TargetsViewerAction.java,v 1.8 2005/03/30 09:56:13 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public class Phase1TargetsViewerAction extends ActionSuperclass {
 /** Standard log channel */
   private static Logger stdlog_ =
       Logger.getLogger(Phase1TargetsViewerAction.class );


	    

    private MainWindow mainWdw_;

    /**
     * Constructs a Phase1TargetsViewerAction action.
     */
    public Phase1TargetsViewerAction(MainWindow mainWdw) {
	super(mainWdw,"View Phase1 Targets");

	mainWdw_ = mainWdw;
    }

    /**
     * Event handler for the Phase1TargetsViewerAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
	JFrame frm;

	if ( ! OHSApplication.ensureAuthenticated() ) {
	    return;
	}

	try {
	    frm = mainWdw_.getPhase1TargetsViewer();
	    frm.pack(); 
	    frm.show();
	}
	catch (ObjectIOException e) {
	    stdlog_.error(e);
	}
    }

}


