package org.eso.ohs.phase2.obHistory;

import java.sql.SQLException;

import org.eso.ohs.core.dbb.server.DbbSession;
import org.eso.ohs.core.dbb.server.DbbSqlEngine;
import org.eso.ohs.core.dbb.server.DbbSqlEngineImpl;
import org.eso.ohs.core.dbb.sql.DbbSqlTable;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.persistence.Config;

/**
 * This class provides only statics to build an OB History database browser
 * <p>
 * @version $Revision: 1.5 $
 * @author Ron J Lobo
 */
public class BrowserConfig {

    public static final String cvsID_ =
        "$Id: BrowserConfig.java,v 1.5 2004/02/17 11:16:25 tcanavan Exp $";

    public static DbbSqlTable OER;
    public static DbbSqlTable OE;
    public static DbbSqlTable OB;

    private static String obrepDbName_ =
        Config.getCfg().getDbName(ObservationBlock.getSuffix());


    public static DbbSqlEngine getEngine() throws SQLException {

        DbbSession session = new DbbSession(
            Config.getCfg().getUrl(ObservationBlock.getSuffix()),
            obrepDbName_,
            Config.getCfg().getDbUserName(),
            Config.getCfg().getDbPassword());

        // set up the tables
        OER = new DbbSqlTable(obrepDbName_, "dbo", "ob_event_register");
        OE  = new DbbSqlTable(obrepDbName_, "dbo", "ob_events");
        OB  = new DbbSqlTable(obrepDbName_, "dbo", "obs_blocks");

        // Create the sql engine
        DbbSqlEngineImpl engine = new DbbSqlEngineImpl(session, false);

        // composite join
        String obID = "ob_id";
        String oerID = "ob_event_register_id";
        String sitecodeID = "sitecode";
        String[] evregCols = { oerID, sitecodeID };
        engine.addCompositeJoinCondition(OER, evregCols, OE, evregCols, false);

        // outer join
        String[] obIdCol = { obID };
        engine.addCompositeJoinCondition(OE, obIdCol, OB, obIdCol, false);

        return engine;
    }
}

