package org.eso.ohs.phase2.orang;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.Hashtable;

import org.eso.ohs.core.utilities.DateContainer;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.phase2.visibility.JulianDate;
import org.eso.ohs.phase2.visibility.VisibilityCalcUtils;
import org.eso.ohs.phase2.visibility.VisibilityJCalc;
import org.eso.ohs.scripting.TimeIntervalSetAPI;
import org.eso.ohs.scripting.TimeIntervalSetAdaptor;

/**
 * 
 *Class mapping the model to the tcl environment
 * 
 * @author pnunes
 *
 */
public class OBScheduleInfoAdaptor implements ObScheduleInfoAPI {
	
	private OBScheduleInfo obSchedInfo;	
			
	/**
	 * Constructor
	 */
	public OBScheduleInfoAdaptor(OBScheduleInfo info) {
		obSchedInfo = info;
	}

	public String getAffil() {
		return (obSchedInfo.getOb().getSchedRun().getAffil());		
	}

	public String getAirmass() {
		return (format(obSchedInfo.getOb().getObInfo().getAirmass()));
	}

	public long getCreationDate() {		
		return (obSchedInfo.getOb().getObInfo().getCreationDate());
	}

	public String getDec() {
		double dec  = Math.toDegrees((obSchedInfo.getOb().getObInfo().getDec() / VisibilityCalcUtils.MILLARC_MMSS) / VisibilityCalcUtils.MILLISECS_PER_SEC);
		return (format(dec));
	}

	public float getDiffDec() {		
		float diffDec = obSchedInfo.getOb().getObInfo().getDiffDec();
		return (diffDec);
	}

	public float getDiffRA() {
		float diffRA = obSchedInfo.getOb().getObInfo().getDiffRA();
		return (diffRA);
	}

	public int getExecutionTime() {
		return (obSchedInfo.getOb().getObInfo().getExecutionTime() );
	}

	public String getFractionalLunarIllumination() {
		return (format(obSchedInfo.getOb().getObInfo().getFractionalLunarIllumination()));
	}

	public long getFromDate() {
		return (obSchedInfo.getOb().getSchedRun().getFromDate());
	}

	public DateContainer getFromDateFields() {
		return (obSchedInfo.getOb().getSchedRun().getFromDateFields());
	}

	public Date getFromDateObj() {
		return (obSchedInfo.getOb().getSchedRun().getFromDateObj());
	}

	public String getFromDateString() {
		return (obSchedInfo.getOb().getSchedRun().getFromDateString());
	}

	public String getInstrument() {
		return (obSchedInfo.getOb().getSchedRun().getInstrument());
	}

	public BigDecimal getIpversion() {
		return (obSchedInfo.getOb().getSchedRun().getIpversion());
	}

	public String getLastMod() {
		return (obSchedInfo.getOb().getSchedRun().getLastMod());
	}

	public String getMonth() {
		return (obSchedInfo.getOb().getSchedRun().getMonth());
	}

	public String getMoon() {
		return (obSchedInfo.getOb().getSchedRun().getMoon());
	}

	public int getMoonAngularDistance() {
		return (obSchedInfo.getOb().getObInfo().getMoonAngularDistance());
	}

	public float getNight() {
		return (obSchedInfo.getOb().getSchedRun().getNight());
	}

	public String getNightAssistant() {
		return (obSchedInfo.getOb().getSchedRun().getNightAssistant());
	}

	public String getNightFract() {
		return (obSchedInfo.getOb().getSchedRun().getNightFract_());
	}

	public String getObserver() {
		return (obSchedInfo.getOb().getSchedRun().getObserver());
	}

	public String getObserverEmail() {
		return (obSchedInfo.getOb().getSchedRun().getObserverEmail());
	}

	public String getObsMode() {
		return (obSchedInfo.getOb().getSchedRun().getObsMode());
	}

	public int getPeriod() {
		return (obSchedInfo.getOb().getSchedRun().getPeriod());
	}

	public String getPiCoi() {
		return (obSchedInfo.getOb().getSchedRun().getPiCoi());
	}

	public String getProgId() {
		return (obSchedInfo.getOb().getSchedRun().getProgId());
	}

	public float getPropDec() {
		float propDec = obSchedInfo.getOb().getObInfo().getPropDec() ;
		return (propDec);
	}

	public float getPropRA() {
		float propRA = obSchedInfo.getOb().getObInfo().getPropRA();
		return (propRA);
	}

	public int getPublished() {
		return (obSchedInfo.getOb().getSchedRun().getPublished());
	}

	public String getRa() {
		double ra  = Math.toDegrees(obSchedInfo.getOb().getObInfo().getRa() * VisibilityCalcUtils.MILLARC_HRMMSS);
		return (format(ra));
	}

	public int getRank() {
		return (obSchedInfo.getOb().getSchedRun().getRank());
	}

	public String getRankClass() {
		return (obSchedInfo.getOb().getSchedRun().getRankClass());
	}

	public String getRemarks() {
		return (obSchedInfo.getOb().getSchedRun().getRemarks());
	}

	public int getRepeats() {
		return (obSchedInfo.getOb().getObInfo().getRepeats());
	}

	public int getRunId() {
		return (obSchedInfo.getOb().getObInfo().getRunId());
	}

	public int getSchedSeeing() {
		return (obSchedInfo.getOb().getSchedRun().getSeeing());
	}

	public String getSeeing() {
		return (format(obSchedInfo.getOb().getObInfo().getSeeing()));
	}

	public String getSeeingString() {
		return (obSchedInfo.getOb().getSchedRun().getSeeingString());
	}

	public String getSkyTransparency() {
		return (obSchedInfo.getOb().getObInfo().getSkyTransparency());
	}

	public String getStatus() {
		return (obSchedInfo.getOb().getObInfo().getStatus());
	}

	public float getStrehlRatio() {
		return (obSchedInfo.getOb().getObInfo().getStrehlRatio());
	}
	
	public String getSupportAssistant() {
		return (obSchedInfo.getOb().getSchedRun().getSupportAssistant());
	}

	public String getTelescope() {
		return (obSchedInfo.getOb().getSchedRun().getTelescope());
	}	

	public String getTitle() {
		return (obSchedInfo.getOb().getSchedRun().getTitle());
	}

	public long getToDate() {
		return (obSchedInfo.getOb().getSchedRun().getToDate());
	}

	public DateContainer getToDateFields() {
		return (obSchedInfo.getOb().getSchedRun().getToDateFields());
	}

	public Date getToDateObj() {
		return (obSchedInfo.getOb().getSchedRun().getToDateObj());
	}

	public String getToDateString() {
		return (obSchedInfo.getOb().getSchedRun().getToDateString());
	}

	public String getType() {
		return (obSchedInfo.getOb().getObInfo().getType());
	}

	public int getUserId() {
		return (obSchedInfo.getOb().getObInfo().getUserId());
	}

	public String getUserPriority() {
		return (format2Places(obSchedInfo.getOb().getObInfo().getUserPriority()));
	}

	public boolean isPublished() {
		return (obSchedInfo.getOb().getSchedRun().isPublished());
	}

	
	
	public TimeIntervalSetAPI getSTTimeIntervals() {
		TimeIntervalSetAPI rc;
        
        rc = new TimeIntervalSetAdaptor( obSchedInfo.getOb().getSiderealTimeIntervals() );
       return rc;
	}
	
	
	public TimeIntervalSetAPI getTimeIntervals() {
        TimeIntervalSetAPI rc;
        
         rc = new TimeIntervalSetAdaptor( obSchedInfo.getOb().getTimeIntervals() );
        return rc;
	}

	
	public String getRankScore() {
		return(obSchedInfo.getRankingScore());
	}
	
	public void setRankScore(String rank) {
		obSchedInfo.setRankingScore(rank);		
	}
	
	
	public boolean getSecondHalfTimeInterval() {
		return(obSchedInfo.isSecondHalfTimeInterval());
	}

	public Hashtable getKWValues() {
		Hashtable res = new Hashtable();
				
		
		res.put("TRUE",new Boolean(true));
		res.put("FALSE",new Boolean(false));
		res.put("AIRMASS",getAirmass() + "" );
		res.put("SEEING",getSeeing() + "");
		res.put("DEC", getDec() + "");
		res.put("RA",getRa() + "");
		res.put("PRIORITY",getUserPriority() + "" );
		res.put("RANKCLASS",getRankClass());
		res.put("2NDHALFTIMEINTERVAL",new Boolean(getSecondHalfTimeInterval()));
		res.put("MOONDISTANCE", getMoonAngularDistance() + "" );
		res.put("EXECUTION_TIME", getExecutionTime() + "" );
		res.put("RANK", getRank() + "");
		res.put("TELESCOPE" , getTelescope());				
		res.put("TRANSPARENCY", getSkyTransparency());
		res.put("INSTRUMENT",getInstrument());
		res.put("FLI",getFractionalLunarIllumination() + "");
		return(res);
	}
	
	
	public String format( float value ) {	
		
		DecimalFormat format = new DecimalFormat("00.00");
		return(format.format(value));
			
	}
	
	public String format( double value ) {	
		
		DecimalFormat format = new DecimalFormat("00.00");
		return(format.format(value));
			
	}
	
	public String format2Places( int value ) {
		DecimalFormat format = new DecimalFormat("00");
		return(format.format(value));
		
	}

	public OBScheduleInfo getObSchedInfo() {
		return obSchedInfo;
	}

    public boolean getChilean() {        
        return obSchedInfo.getOb().getRunProperties().isChilean();
    }

    public boolean getPreImaging() {
        return obSchedInfo.getOb().getRunProperties().isPreImaging();
    }

    public boolean getCarryOver() {
        return obSchedInfo.getOb().getRunProperties().isCarryOver();
    }

    public boolean getLarge() {
        return obSchedInfo.getOb().getRunProperties().isLarge();
    }

    public boolean getTimeCritical() {      
        return obSchedInfo.getOb().getRunProperties().isTimeCritical();
    }
    
    public boolean isRunStarted() {      
        return obSchedInfo.getOb().getRunProperties().isRunStarted();
    }

	/* (non-Javadoc)
	 * @see org.eso.ohs.phase2.orang.ObScheduleInfoAPI#getLST()
	 */
	public double getLST() {

		Date start = obSchedInfo.getStart();
		double jdate = JulianDate.getJDC(start);
		double longitude = AppConfig.getAppConfig().getLongitude();
		VisibilityJCalc visi = new VisibilityJCalc();
		return( visi.getLST(jdate,longitude) );
	}
    
    
	
	
	
}
